'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
var cloneDeep = require("lodash.clonedeep");
var isNil = require("lodash.isnil");
function get(object, keys) {
    return getter(cloneDeep(object), keys);
}
exports.get = get;
var getter = function (object, keys) {
    var head = keys[0], tail = keys.slice(1);
    var next = object[head];
    if (isNil(next)) {
        return;
    }
    if (tail.length === 0) {
        return Object.freeze(next);
    }
    return getter(next, tail);
};
