'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
var cloneDeep = require("lodash.clonedeep");
var isNil = require("lodash.isnil");
function set(object, keys, value) {
    var cloned = cloneDeep(object);
    return setter(cloned, cloned, keys, value);
}
exports.set = set;
var setter = function (baseObject, object, keys, value) {
    var head = keys[0], tail = keys.slice(1);
    var next = object[head];
    if (isNil(next)) {
        return Object.freeze(baseObject);
    }
    if (tail.length === 0) {
        object[head] = value;
        return Object.freeze(baseObject);
    }
    return setter(baseObject, next, tail, value);
};
